/*     */ package org.codehaus.commons.compiler.samples;
/*     */ 
/*     */ import java.lang.reflect.Array;
/*     */ import java.lang.reflect.Constructor;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import java.util.StringTokenizer;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DemoBase
/*     */ {
/*     */   public static Object createObject(Class type, String value)
/*     */     throws NoSuchMethodException, InstantiationException, InvocationTargetException, IllegalAccessException
/*     */   {
/*  49 */     if (type.isPrimitive()) {
/*  50 */       type = type == Double.TYPE ? Double.class : type == Float.TYPE ? Float.class : type == Long.TYPE ? Long.class : type == Integer.TYPE ? Integer.class : type == Short.TYPE ? Short.class : type == Byte.TYPE ? Byte.class : type == Character.TYPE ? Character.class : type == Boolean.TYPE ? Boolean.class : Void.TYPE;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  64 */     if (value.equals("")) {
/*  65 */       return type.getConstructor(new Class[0]).newInstance(new Object[0]);
/*     */     }
/*  67 */     return type.getConstructor(new Class[] { String.class }).newInstance(new Object[] { value });
/*     */   }
/*     */   
/*     */   public static String[] explode(String s)
/*     */   {
/*  72 */     StringTokenizer st = new StringTokenizer(s, ",");
/*  73 */     List l = new ArrayList();
/*  74 */     while (st.hasMoreTokens()) l.add(st.nextToken());
/*  75 */     return (String[])l.toArray(new String[l.size()]);
/*     */   }
/*     */   
/*     */   public static Class stringToType(String s) {
/*  79 */     int brackets = 0;
/*  80 */     while (s.endsWith("[]")) {
/*  81 */       brackets++;
/*  82 */       s = s.substring(0, s.length() - 2);
/*     */     }
/*     */     
/*  85 */     if (brackets == 0)
/*     */     {
/*  87 */       if (s.equals("void")) return Void.TYPE;
/*  88 */       if (s.equals("boolean")) return Boolean.TYPE;
/*  89 */       if (s.equals("char")) return Character.TYPE;
/*  90 */       if (s.equals("byte")) return Byte.TYPE;
/*  91 */       if (s.equals("short")) return Short.TYPE;
/*  92 */       if (s.equals("int")) return Integer.TYPE;
/*  93 */       if (s.equals("long")) return Long.TYPE;
/*  94 */       if (s.equals("float")) return Float.TYPE;
/*  95 */       if (s.equals("double")) { return Double.TYPE;
/*     */       }
/*     */     }
/*     */     
/*  99 */     if (s.equals("void")) { s = "V";
/* 100 */     } else if (s.equals("boolean")) { s = "Z";
/* 101 */     } else if (s.equals("char")) { s = "C";
/* 102 */     } else if (s.equals("byte")) { s = "B";
/* 103 */     } else if (s.equals("short")) { s = "S";
/* 104 */     } else if (s.equals("int")) { s = "I";
/* 105 */     } else if (s.equals("long")) { s = "J";
/* 106 */     } else if (s.equals("float")) { s = "F";
/* 107 */     } else if (s.equals("double")) s = "D";
/*     */     for (;;) {
/* 109 */       brackets--; if (brackets < 0) break; s = '[' + s;
/*     */     }
/* 111 */     try { return Class.forName(s);
/*     */     } catch (ClassNotFoundException ex) {
/* 113 */       ex.printStackTrace();
/* 114 */       System.exit(1);
/* 115 */       throw new RuntimeException();
/*     */     }
/*     */   }
/*     */   
/*     */   public static Class[] stringToTypes(String s) {
/* 120 */     StringTokenizer st = new StringTokenizer(s, ",");
/* 121 */     List l = new ArrayList();
/* 122 */     while (st.hasMoreTokens()) l.add(stringToType(st.nextToken()));
/* 123 */     Class[] res = new Class[l.size()];
/* 124 */     l.toArray(res);
/* 125 */     return res;
/*     */   }
/*     */   
/*     */   public static String toString(Object o) {
/* 129 */     if (o == null) { return "(null)";
/*     */     }
/*     */     
/* 132 */     Class clazz = o.getClass();
/* 133 */     if (clazz.isArray()) {
/* 134 */       StringBuffer sb = new StringBuffer(clazz.getComponentType().toString()).append("[] { ");
/* 135 */       for (int i = 0; i < Array.getLength(o); i++) {
/* 136 */         if (i > 0) sb.append(", ");
/* 137 */         sb.append(toString(Array.get(o, i)));
/*     */       }
/* 139 */       sb.append(" }");
/* 140 */       return sb.toString();
/*     */     }
/*     */     
/*     */ 
/* 144 */     return o.toString();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\commons\compiler\samples\DemoBase.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */